
 format    binary as 'img'
 org       0x0800
 use16


 boot:  jmp     short segs
        nop

 bsOemName               DB      "MSDOS5.0"      ; 0x03
 bpbBytesPerSector       DW      512             ; 0x0B
 bpbSectorsPerCluster    DB      1               ; 0x0D
 bpbReservedSectors      DW      1               ; 0x0E
 bpbNumberOfFATs         DB      2               ; 0x10
 bpbRootEntries          DW      224             ; 0x11
 bpbTotalSectors         DW      2880            ; 0x13
 bpbMedia                DB      0F0h            ; 0x15
 bpbSectorsPerFAT        DW      9               ; 0x16
 bpbSectorsPerTrack      DW      18              ; 0x18
 bpbHeadsPerCylinder     DW      2               ; 0x1A

 Address:
 bpbHiddenSectors        DD      0               ; 0x1C
 bpbTotalSectorsBig      DD      0               ; 0x20

 bsDriveNumber           DB      0               ; 0x24
 bsUnused                DB      0               ; 0x25
 bsExtBootSignature      DB      29H             ; 0x26
 bsSerialNumber          DD      1;11223344h     ; 0x27
 bsVolumeLabel           DB      "BOOT FLOPPY"   ; 0x2B
 bsFileSystem            DB      "FAT12   "      ; 0x36

 segs:     cli                      ; set up segments
           xor     bx, bx           ;
           mov     ds, bx           ;
           mov     es, bx           ;
           mov     ss, bx           ;
           mov     sp, 0x0800       ;
           sti                      ;

 copy:     cld
           mov     di, sp           ; don't care if start
           mov     si, 0x7C00       ; is clobberred
           mov     ch, 0x01         ; at least 512 bytes
           rep     movsw            ;
           push    0x00A0           ;
           pop     es               ;
           xor     di, di           ; lba
           jmp     0x0000:seek

 gdt:      dq 0x0000000000000000
           dq 0x00CF92000000FFFF
           dq 0x00CF9A000000FFFF
 pad:      db 'xx'
 gdtr:     dw pad-gdt-1
           dd gdt

 reset:    xor     ax, ax           ; reset floppy
           int     0x13             ;
 read:     mov     ax, di           ; grab lba
           aam     0x12             ; extract sector

          ;xchg    ax, cx           ; cl = sector
          ;inc     cx               ; range 1-18
           mov     cl, al           ; cl = sector
           inc     cx               ; range 1-18
           shr     ax, 0x08         ; lba/18
           aam     0x02             ; extract head
           mov     dh, al           ; dh = head
           mov     ch, ah           ; ch = cylinder
           mov     ax, 0x0201       ; read 1 sectors
           int     0x13             ; (i know it's slow)
           jc      reset            ;
 save:     mov     [es:bx], di
           mov     [es:bx+0x02], cx
           mov     [es:bx+0x04], dx

 move:     mov     ax, es           ; slide es window
           add     ax, 0x0020       ; to next sector
           mov     es, ax           ;
 seek:     inc     di               ; next lba
           cmp     di, 4*18         ; want 2xtracks
           jb      read             ;
 mode:     mov     ax, 0x0003       ; text mode 80x25
           int     0x10             ;
           mov     ax, 0x0100       ; without blinker
           mov     cx, 0x2000       ;
           int     0x10             ;
           cli                      ;



           lgdt    [gdtr]           ;
           mov     eax, cr0         ;
           or      al, 0x01         ;
           mov     cr0, eax         ;
           mov     ax, 0x0008       ;
           mov     ds, ax           ;
           mov     es, ax           ;
           mov     ss, ax           ;
           jmp     0x0010:pm32      ;
 use32
 pm32:     mov     esp, 0x00000800  ;
 main:     mov     esi, Address
           mov     ecx, 0x00100000
           loop    $
           mov     cl, 0x10
           mov     dx, 0x03DA
 .Sync:    in      al, dx
           test    al, 0x08
           jz      .Sync

           xor     eax, eax
           in      al, 0x60
 .down:    cmp     al, 0x50 ; KEY DOWN
           jne     .up
           add     [esi], ecx
 .up:      cmp     al, 0x48 ; KEY UP
           jne     .pgup
           sub     [esi], ecx
 .pgup:    mov     cl, 0xB0
           cmp     al, 0x51 ; KEY PGDN
           jne     .pgdn
           add     [esi], ecx
 .pgdn:    cmp     al, 0x49 ; KEY PGUP
           jne     .draw
           sub     [esi], ecx
 .draw:    mov     esi, [esi]
           call    PrintRam
           jmp     main

 PrintRam: mov     edi, 0x000B8000
           mov     ebp, 25
.NextLine: mov     edx, esi
           mov     cl, 0x08

           mov     ah, 0x1F
           mov     al, ' '
           stosw
.Address:  rol     edx, 0x04
           xor     eax, eax
           mov     al, dl
           and     al, 0x0F
           mov     ebx, eax
           add     bl, '0'
           cmp     al, 9
           cmovbe  eax, ebx
           add     bl, 'A'-'0'-0x0A
           cmp     al, '0'
           cmovb   eax, ebx
           mov     ah, 0x1F
           stosw
           loop    .Address

           mov     al, ':'
           stosw
           mov     al, ' '
           stosw


           push    esi
           mov     cl, 0x10
.Bytes:
           xor     eax, eax
           lodsb

           mov     edx, eax
           rol     dl, 0x04
           mov     al, dl
           and     al, 0x0F
           mov     ebx, eax
           add     bl, '0'
           cmp     al, 9
           cmovbe  eax, ebx
           add     bl, 'A'-'0'-0x0A
           cmp     al, '0'
           cmovb   eax, ebx
           mov     ah, 0x1F
           stosw

           xor     eax, eax
           rol     dl, 0x04
           mov     al, dl
           and     al, 0x0F
           mov     ebx, eax
           add     bl, '0'
           cmp     al, 9
           cmovbe  eax, ebx
           add     bl, 'A'-'0'-0x0A
           cmp     al, '0'
           cmovb   eax, ebx
           mov     ah, 0x1F
           stosw

           mov     al, ' '
           stosw
           loop    .Bytes
           pop     esi

           mov     al, ';'
           stosw
           mov     al, ' '
           stosw

           mov     cl, 0x10
.Ascii:
           xor     eax, eax
           lodsb
           mov     ah, 0x1F
           stosw
           loop    .Ascii

           mov     al, ' '
           stosw
           stosw
           stosw
           dec     ebp
           jnz     .NextLine
           ret

           db $$-$+510 dup 0
 sig:      dw 0xAA55

;dd 128 dup '000 ' ;0:02
 dd 128 dup '001 ' ;0:02
 dd 128 dup '002 ' ;0:02
 dd 128 dup '003 ' ;0:03
 dd 128 dup '004 ' ;0:04
 dd 128 dup '005 ' ;0:05
 dd 128 dup '006 ' ;0:06
 dd 128 dup '007 ' ;0:07
 dd 128 dup '008 ' ;0:08
 dd 128 dup '009 ' ;0:09
 dd 128 dup '00A ' ;0:0A
 dd 128 dup '00B ' ;0:0B
 dd 128 dup '00C ' ;0:0C
 dd 128 dup '00D ' ;0:0D
 dd 128 dup '00E ' ;0:0E
 dd 128 dup '00F ' ;0:0F
 dd 128 dup '010 ' ;0:02
 dd 128 dup '011 ' ;0:02
 dd 128 dup '012 ' ;0:02
 dd 128 dup '013 ' ;0:03
 dd 128 dup '014 ' ;0:04
 dd 128 dup '015 ' ;0:05
 dd 128 dup '016 ' ;0:06
 dd 128 dup '017 ' ;0:07
 dd 128 dup '018 ' ;0:08
 dd 128 dup '019 ' ;0:09
 dd 128 dup '01A ' ;0:0A
 dd 128 dup '01B ' ;0:0B
 dd 128 dup '01C ' ;0:0C
 dd 128 dup '01D ' ;0:0D
 dd 128 dup '01E ' ;0:0E
 dd 128 dup '01F ' ;0:0F
 dd 128 dup '020 ' ;0:02
 dd 128 dup '021 ' ;0:02
 dd 128 dup '022 ' ;0:02
 dd 128 dup '023 ' ;0:03
 dd 128 dup '024 ' ;0:04
 dd 128 dup '025 ' ;0:05
 dd 128 dup '026 ' ;0:06
 dd 128 dup '027 ' ;0:07
 dd 128 dup '028 ' ;0:08
 dd 128 dup '029 ' ;0:09
 dd 128 dup '02A ' ;0:0A
 dd 128 dup '02B ' ;0:0B
 dd 128 dup '02C ' ;0:0C
 dd 128 dup '02D ' ;0:0D
 dd 128 dup '02E ' ;0:0E
 dd 128 dup '02F ' ;0:0F
 dd 128 dup '030 ' ;0:02
 dd 128 dup '031 ' ;0:02
 dd 128 dup '032 ' ;0:02
 dd 128 dup '033 ' ;0:03
 dd 128 dup '034 ' ;0:04
 dd 128 dup '035 ' ;0:05
 dd 128 dup '036 ' ;0:06
 dd 128 dup '037 ' ;0:07
 dd 128 dup '038 ' ;0:08
 dd 128 dup '039 ' ;0:09
 dd 128 dup '03A ' ;0:0A
 dd 128 dup '03B ' ;0:0B
 dd 128 dup '03C ' ;0:0C
 dd 128 dup '03D ' ;0:0D
 dd 128 dup '03E ' ;0:0E
 dd 128 dup '03F ' ;0:0F
 dd 128 dup '040 ' ;0:02
 dd 128 dup '041 ' ;0:02
 dd 128 dup '042 ' ;0:02
 dd 128 dup '043 ' ;0:03
 dd 128 dup '044 ' ;0:04
 dd 128 dup '045 ' ;0:05
 dd 128 dup '046 ' ;0:06
 dd 128 dup '047 ' ;0:07
 dd 128 dup '048 ' ;0:08
 dd 128 dup '049 ' ;0:09
 dd 128 dup '04A ' ;0:0A
 dd 128 dup '04B ' ;0:0B
 dd 128 dup '04C ' ;0:0C
 dd 128 dup '04D ' ;0:0D
 dd 128 dup '04E ' ;0:0E
 dd 128 dup '04F ' ;0:0F
 dd 128 dup '050 ' ;0:02
 dd 128 dup '051 ' ;0:03
 dd 128 dup '052 ' ;0:02
 dd 128 dup '053 ' ;0:03
 dd 128 dup '054 ' ;0:04
 dd 128 dup '055 ' ;0:05
 dd 128 dup '056 ' ;0:06
 dd 128 dup '057 ' ;0:07
 dd 128 dup '058 ' ;0:08
 dd 128 dup '059 ' ;0:09
 dd 128 dup '05A ' ;0:0A
 dd 128 dup '05B ' ;0:0B
 dd 128 dup '05C ' ;0:0C
 dd 128 dup '05D ' ;0:0D
 dd 128 dup '05E ' ;0:0E
 dd 128 dup '05F ' ;0:0F
 dd 128 dup '060 ' ;0:02
 dd 128 dup '061 ' ;0:03
 dd 128 dup '062 ' ;0:02
 dd 128 dup '063 ' ;0:03
 dd 128 dup '064 ' ;0:04
 dd 128 dup '065 ' ;0:05
 dd 128 dup '066 ' ;0:06
 dd 128 dup '067 ' ;0:07
 dd 128 dup '068 ' ;0:08
 dd 128 dup '069 ' ;0:09
 dd 128 dup '06A ' ;0:0A
 dd 128 dup '06B ' ;0:0B
 dd 128 dup '06C ' ;0:0C
 dd 128 dup '06D ' ;0:0D
 dd 128 dup '06E ' ;0:0E
 dd 128 dup '06F ' ;0:0F
 dd 128 dup '070 ' ;0:02
 dd 128 dup '071 ' ;0:03
 dd 128 dup '072 ' ;0:02
 dd 128 dup '073 ' ;0:03
 dd 128 dup '074 ' ;0:04
 dd 128 dup '075 ' ;0:05
 dd 128 dup '076 ' ;0:06
 dd 128 dup '077 ' ;0:07
 dd 128 dup '078 ' ;0:08
 dd 128 dup '079 ' ;0:09
 dd 128 dup '07A ' ;0:0A
 dd 128 dup '07B ' ;0:0B
 dd 128 dup '07C ' ;0:0C
 dd 128 dup '07D ' ;0:0D
 dd 128 dup '07E ' ;0:0E
 dd 128 dup '07F ' ;0:0F
 dd 128 dup '080 ' ;0:02
 dd 128 dup '081 ' ;0:03
 dd 128 dup '082 ' ;0:02
 dd 128 dup '083 ' ;0:03
 dd 128 dup '084 ' ;0:04
 dd 128 dup '085 ' ;0:05
 dd 128 dup '086 ' ;0:06
 dd 128 dup '087 ' ;0:07
 dd 128 dup '088 ' ;0:08
 dd 128 dup '089 ' ;0:09
 dd 128 dup '08A ' ;0:0A
 dd 128 dup '08B ' ;0:0B
 dd 128 dup '08C ' ;0:0C
 dd 128 dup '08D ' ;0:0D
 dd 128 dup '08E ' ;0:0E
 dd 128 dup '08F ' ;0:0F
 dd 128 dup '090 ' ;0:02
 dd 128 dup '091 ' ;0:03
 dd 128 dup '092 ' ;0:02
 dd 128 dup '093 ' ;0:03
 dd 128 dup '094 ' ;0:04
 dd 128 dup '095 ' ;0:05
 dd 128 dup '096 ' ;0:06
 dd 128 dup '097 ' ;0:07
 dd 128 dup '098 ' ;0:08
 dd 128 dup '099 ' ;0:09
 dd 128 dup '09A ' ;0:0A
 dd 128 dup '09B ' ;0:0B
 dd 128 dup '09C ' ;0:0C
 dd 128 dup '09D ' ;0:0D
 dd 128 dup '09E ' ;0:0E
 dd 128 dup '09F ' ;0:0F
 dd 128 dup '0A0 ' ;0:02
 dd 128 dup '0A1 ' ;0:03
 dd 128 dup '0A2 ' ;0:02
 dd 128 dup '0A3 ' ;0:03
 dd 128 dup '0A4 ' ;0:04
 dd 128 dup '0A5 ' ;0:05
 dd 128 dup '0A6 ' ;0:06
 dd 128 dup '0A7 ' ;0:07
 dd 128 dup '0A8 ' ;0:08
 dd 128 dup '0A9 ' ;0:09
 dd 128 dup '0AA ' ;0:0A
 dd 128 dup '0AB ' ;0:0B
 dd 128 dup '0AC ' ;0:0C
 dd 128 dup '0AD ' ;0:0D
 dd 128 dup '0AE ' ;0:0E
 dd 128 dup '0AF ' ;0:0F
 dd 128 dup '0B0 ' ;0:02
 dd 128 dup '0B1 ' ;0:03
 dd 128 dup '0B2 ' ;0:02
 dd 128 dup '0B3 ' ;0:03
 dd 128 dup '0B4 ' ;0:04
 dd 128 dup '0B5 ' ;0:05
 dd 128 dup '0B6 ' ;0:06
 dd 128 dup '0B7 ' ;0:07
 dd 128 dup '0B8 ' ;0:08
 dd 128 dup '0B9 ' ;0:09
 dd 128 dup '0BA ' ;0:0A
 dd 128 dup '0BB ' ;0:0B
 dd 128 dup '0BC ' ;0:0C
 dd 128 dup '0BD ' ;0:0D
 dd 128 dup '0BE ' ;0:0E
 dd 128 dup '0BF ' ;0:0F
 dd 128 dup '0C0 ' ;0:02
 dd 128 dup '0C1 ' ;0:03
 dd 128 dup '0C2 ' ;0:02
 dd 128 dup '0C3 ' ;0:03
 dd 128 dup '0C4 ' ;0:04
 dd 128 dup '0C5 ' ;0:05
 dd 128 dup '0C6 ' ;0:06
 dd 128 dup '0C7 ' ;0:07
 dd 128 dup '0C8 ' ;0:08
 dd 128 dup '0C9 ' ;0:09
 dd 128 dup '0CA ' ;0:0A
 dd 128 dup '0CB ' ;0:0B
 dd 128 dup '0CC ' ;0:0C
 dd 128 dup '0CD ' ;0:0D
 dd 128 dup '0CE ' ;0:0E
 dd 128 dup '0CF ' ;0:0F
 dd 128 dup '0D0 ' ;0:02
 dd 128 dup '0D1 ' ;0:03
 dd 128 dup '0D2 ' ;0:02
 dd 128 dup '0D3 ' ;0:03
 dd 128 dup '0D4 ' ;0:04
 dd 128 dup '0D5 ' ;0:05
 dd 128 dup '0D6 ' ;0:06
 dd 128 dup '0D7 ' ;0:07
 dd 128 dup '0D8 ' ;0:08
 dd 128 dup '0D9 ' ;0:09
 dd 128 dup '0DA ' ;0:0A
 dd 128 dup '0DB ' ;0:0B
 dd 128 dup '0DC ' ;0:0C
 dd 128 dup '0DD ' ;0:0D
 dd 128 dup '0DE ' ;0:0E
 dd 128 dup '0DF ' ;0:0F
 dd 128 dup '0E0 ' ;0:02
 dd 128 dup '0E1 ' ;0:03
 dd 128 dup '0E2 ' ;0:02
 dd 128 dup '0E3 ' ;0:03
 dd 128 dup '0E4 ' ;0:04
 dd 128 dup '0E5 ' ;0:05
 dd 128 dup '0E6 ' ;0:06
 dd 128 dup '0E7 ' ;0:07
 dd 128 dup '0E8 ' ;0:08
 dd 128 dup '0E9 ' ;0:09
 dd 128 dup '0EA ' ;0:0A
 dd 128 dup '0EB ' ;0:0B
 dd 128 dup '0EC ' ;0:0C
 dd 128 dup '0ED ' ;0:0D
 dd 128 dup '0EE ' ;0:0E
 dd 128 dup '0EF ' ;0:0F
 dd 128 dup '0F0 ' ;0:02
 dd 128 dup '0F1 ' ;0:03
 dd 128 dup '0F2 ' ;0:02
 dd 128 dup '0F3 ' ;0:03
 dd 128 dup '0F4 ' ;0:04
 dd 128 dup '0F5 ' ;0:05
 dd 128 dup '0F6 ' ;0:06
 dd 128 dup '0F7 ' ;0:07
 dd 128 dup '0F8 ' ;0:08
 dd 128 dup '0F9 ' ;0:09
 dd 128 dup '0FA ' ;0:0A
 dd 128 dup '0FB ' ;0:0B
 dd 128 dup '0FC ' ;0:0C
 dd 128 dup '0FD ' ;0:0D
 dd 128 dup '0FE ' ;0:0E
 dd 128 dup '0FF ' ;0:0F
